local frame = CreateFrame("FRAME");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");

local saverTimer = CreateFrame("FRAME");
local updateTimer = CreateFrame("FRAME");

local saverTimerElapsed = 0;
local function OnSaverTimerUpdate(self,elapsed)
    saverTimerElapsed = saverTimerElapsed + elapsed
    if saverTimerElapsed >= 5 then
        UpdateBlackListArray()
		saverTimerElapsed = 0
    end
end

local updateTimerElapsed = 0;
local function OnUpdateTimerUpdate(self,elapsed)
    updateTimerElapsed = updateTimerElapsed + elapsed
    if updateTimerElapsed >= 10 then 
		--  
		AddonLoaded()
		updateTimer:SetScript("OnUpdate", nil)	

		--    
		saverTimer:SetScript("OnUpdate", OnSaverTimerUpdate)		
    end
end

-- Events --->
function frame:OnEvent(event, arg1)
	if event == "PLAYER_ENTERING_WORLD" then
		updateTimer:SetScript("OnUpdate", OnUpdateTimerUpdate)		
	end
end
frame:SetScript("OnEvent", frame.OnEvent);
-- <---Events

function AddonLoaded()
	if BlackListBGs == nil then
		UpdateBlackListArray()
	else
		local previewBlacklist = { GetBlacklistMap(1), GetBlacklistMap(2) }
		table.foreach(previewBlacklist, 
			function(index, mapId)
				if mapId and mapId > 0 then
					ClearBlacklistMap(mapId)
				end
			end)

		table.foreach(BlackListBGs, 
			function(index, mapId)
				if mapId and mapId > 0 then
					SetBlacklistMap(mapId)
				end
			end)
	end
end

function UpdateBlackListArray()
	BlackListBGs = { GetBlacklistMap(1), GetBlacklistMap(2) }
end
